'''
    Mapseg, a program for segmenting maps and producing OSM polygons
    Copyright (C) 2010 Tim Sheerman-Chase

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 or version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

def ExportOsm(polys, filename):
	nodeCount = 0
	wayCount = 0
	fi = open(filename,"wt")
	fi.write("<?xml version='1.0' encoding='UTF-8'?>\n")
	fi.write("<osm version='0.6' generator='exportosm.py'>\n")

	nodeMap = {}

	for poly in polys:
		outer = poly['outer']
		#print outer

		memberNodes = []
		for point in outer['path']:
			if point not in nodeMap:
				nodeId = - nodeCount - 1
				nodeCount = nodeCount + 1
				nodeMap[point] = nodeId
				fi.write("<node id='"+str(nodeMap[point])\
					+"' action='modify' visible='true' lat='"+str(point[0])+"' lon='"+str(point[1])+"' />\n")

			memberNodes.append(nodeMap[point])

		wayId = -wayCount-1
		fi.write("<way id='"+str(wayId)+"' action='modify' visible='true'>\n")
		for nodeId in memberNodes:
			fi.write("<nd ref='"+str(nodeId)+"' />\n")

		#fi.write("<tag k='building' v='yes' />\n")
		#fi.write("<tag k='source' v='auto_os_street_view' />\n")
		#if len(outer['meta']) > 0:
		#	print outer['meta']
		for key in outer['meta'].keys():
			#print key, outer['meta'][key]
			fi.write("<tag k='"+str(key)+"' v='"+str(outer['meta'][key])+"' />\n")

		fi.write("</way>\n")
		wayCount = wayCount + 1
	fi.write("</osm>\n")

